# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::CognitiveServices::Personalizer::V1_0
  module Models
    #
    # A resulting ordered list of actions that result from a rank request.
    #
    class RankResponse

      include MsRestAzure

      # @return [Array<RankedAction>] The calculated ranking for the current
      # request.
      attr_accessor :ranking

      # @return [String] The eventId for the round trip from request to
      # response.
      attr_accessor :event_id

      # @return [String] The action chosen by the Personalizer service. This is
      # the action for which to report the reward. This might not be the
      # first found in 'ranking' if an action in the request in first position
      # was part of the excluded ids.
      attr_accessor :reward_action_id


      #
      # Mapper for RankResponse class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'RankResponse',
          type: {
            name: 'Composite',
            class_name: 'RankResponse',
            model_properties: {
              ranking: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'ranking',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'RankedActionElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'RankedAction'
                      }
                  }
                }
              },
              event_id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'eventId',
                constraints: {
                  MaxLength: 256
                },
                type: {
                  name: 'String'
                }
              },
              reward_action_id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'rewardActionId',
                constraints: {
                  MaxLength: 256
                },
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
